/**********************************************************
System C osztaly
Itt mar a hardware irjuk le, C++ eszkozokkel.
**********************************************************/
#pragma once
#include <systemc.h>

SC_MODULE(shiftreg_sc) // az SC_MODULE valojaban egy sc_module-bol szarmaztatott osztaly
{
	// input portok 
	sc_in<bool>		reset;
	sc_in<bool>		enable;
	sc_in<bool>		clk;
	sc_in<bool>		serial_in;
	
	// output port - 16 bites 
	sc_out<sc_uint<16> >	outreg;


	// a mukodes leirasa
	void	do_shift()
	{
		if (reset.read() == 0) {// alacsony aktiv reset
			outreg = 0;
		} else {
			if (enable == true)
				outreg = (outreg.read() << 1) | (int)serial_in;
		}		
	}


	SC_CTOR(shiftreg_sc)
	{
		SC_METHOD(do_shift);
		sensitive << clk.pos() << reset.neg();	// az erzekenysegi lista megadasa
	}
};

